{$A+,B-,D-,E-,G-,F-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 2048,0,131072}

USES
  dos;

CONST
  bufsize = 1024*62;
  kes : string[18] = ' and press any key';
  inm : string[27] = 'Insert disk with archives #';
  inm2 : string[26] = 'Insert disk for archives #';
  am : string[41] = 'Extra Archivist v3.03 (C) 1992 Lidovsky V';
  h = ^j^m;

TYPE
  srr1 = string[127];

VAR
  buf : array [1..bufsize + 7] of byte;
  r : registers;
  s : srr1;
  fun : pathstr;
  en : extstr;
  fn : namestr;
  dn, ddn : string[2];
  wc : char;
  verify, b1, b2 : boolean;
  fi, fo : file;
  l, m : longint;
  i, j : integer;

FUNCTION discspace(n : char) : longint;
  begin
    discspace := diskfree(ord(upcase(n)) - 64)
   end;

PROCEDURE getk;                   (* wc *)
  begin
    asm
   @1:mov ah, 1
      int 16h
      jz @1
      mov ah, 0
      int 16h
      mov wc,  al
    end
  end;

PROCEDURE gtky(a : srr1; n : byte);    (* wc *)
  begin
    repeat
      getk;
      wc := upcase(wc)
    until pos(wc, a) > 0;
    if n > 0 then
      writeln(wc)
 end;

PROCEDURE beep;
  begin
    write(#7#7)
  end;

PROCEDURE error(n : byte);
  begin
    case n of
      1: writeln(
'USAGE: ea d|v|c|m [drive][path]<source filename>[.ext] <destination drive>',
h, '           d    Divide long file into (floppy''s) archival files',
h, '           v    divide file into (floppy''s) archival files with Verification',
h, '           c    Construct long file from (floppy''s) archival files',
h, '           m    Move long file from archival files',
h, 'e.g.   ea v c:\mydir\myfile.arj a:',
h, '       ea m a:myarc.#00 c:');
      2: writeln('Can''t find ', fun);
      3: writeln('Old format not supported here. Use copy option.');
      4: writeln('Not enough free space on destination drive');
    end;
    setverify(verify);
    halt(n)
  end;

PROCEDURE br(n : word; o : byte);
  begin
    repeat
      wc := 'X';
{$I-}
      blockread(fi, buf[o], n);
      if ioresult <> 0 then begin
        write('I/O READ ERROR: Retry, Ignore, Abort? ');
        gtky('ARI', 1);
        case wc of
          'A': error(7);
          'I': seek(fi, filepos(fi)+n)
        end
      end
{$I+}
    until wc<>'R'
  end;

PROCEDURE bw(n : word);
  begin
    repeat
      wc := 'X';
{$I-}
      blockwrite(fo, buf, n);
      if ioresult <> 0 then begin
        write('I/O WRITE ERROR: Retry, Abort? ');
        gtky('RA', 1);
        if wc = 'A' then
          error(9)
      end
{$I+}
    until wc<>'R'
  end;

PROCEDURE oldc;
  begin
    i := 1;
    br(4, 1);
    j := buf[4];
    s := chr(buf[1]) + chr(buf[2]) + chr(buf[3]);
    s := ddn + fn + '.' + s;
    assign(fo, s);
    rewrite(fo, 1);
    m := filesize(fi) - 4;
    while m div bufsize > 0 do begin
      br(bufsize, 1);
      bw(bufsize);
      m := m-bufsize
    end;
    br(m, 1);
    bw(m);
    close(fi);
    while j = 0 do begin
      inc(i);
      s := dn + fun + '.' + chr(i div 10 + 48) + chr(i mod 10 + 48) + '$';
      assign(fi, s);
{$I-}
      reset(fi, 1);
      while ioresult <> 0 do begin
        beep;
        writeln(inm, i, kes);
        getk;
        reset(fi, 1)
      end;
{$I+}
      br(4, 1);
      j := buf[4];
      m := filesize(fi) - 4;
      while m div bufsize > 0 do begin
        br(bufsize, 1);
        bw(bufsize);
        m := m - bufsize
      end;
      br(m, 1);
      bw(m);
      close(fi)
    end;
    close(fo)
  end;

FUNCTION ackexit : boolean;
  begin
    write(
'Warning! Target drive hasn''t probably enough free space. Break operation? (Y/N)');
    gtky('YN', 0);
    writeln;
    ackexit := wc = 'Y'
  end;

PROCEDURE longc;
  begin
    i := 0;
    br(7, 1);
    l := meml[dseg : ofs(buf)];
    if l > discspace(ddn[1]) then
      if ackexit then begin
        close(fi);
        error(4)
      end;
    s := chr(buf[5]) + chr(buf[6]) + chr(buf[7]);
    s := ddn + fn + '.' + s;
    assign(fo, s);
    rewrite(fo, 1);
    m := filesize(fi) - 7;
    while m div bufsize > 0 do begin
      br(bufsize, 1);
      bw(bufsize);
      l := l - bufsize;
      m := m - bufsize
    end;
    br(m, 1);
    bw(m);
    l := l - m;
    close(fi);
    while l > 0 do begin
      i := i + 1;
      s := dn + fun + '.#' + chr(i div 10 + 48) + chr(i mod 10 + 48);
      assign(fi, s);
{$I-}
      reset(fi, 1);
      while ioresult <> 0 do begin
        beep;
        writeln(inm, i, kes);
        getk;
        reset(fi, 1)
      end;
{$I+}
      m := filesize(fi);
      while m div bufsize > 0 do begin
        br(bufsize, 1);
        bw(bufsize);
        l := l - bufsize;
        m := m - bufsize
      end;
      br(m, 1);
      bw(m);
      l := l - m;
      close(fi)
    end;
    close(fo)
  end;

PROCEDURE longm;
  label 7;
  begin
    i := 0;
    l := discspace(ddn[1]);
    if dn[1] = ddn[1] then
{$I-}
     repeat
       s := dn + fun + '.#' + chr(i div 10 + 48) + chr(i mod 10 + 48);
       assign(fi, s);
       reset(fi, 1);
       if ioresult <> 0 then
         break;
       if l < filesize(fi) then
         if ackexit then
           goto 7;
       close(fi);
       inc(i)
     until false;
{$I+}
     s := dn + fun + '.#00';
     i := 0;
     assign(fi, s);
     reset(fi, 1);
     br(7, 1);
     l := meml[dseg : ofs(buf)];
     if l > discspace(ddn[1]) then
       if ackexit then begin
       7:close(fi);
         error(4)
       end;
     s := chr(buf[5]) + chr(buf[6]) + chr(buf[7]);
     s := ddn + fn + '.' + s;
     assign(fo, s);
     rewrite(fo, 1);
     m := filesize(fi) - 7;
     while m div bufsize > 0 do begin
       br(bufsize, 1);
       bw(bufsize);
       l := l - bufsize;
       m := m - bufsize
     end;
     br(m, 1);
     bw(m);
     l := l - m;
     close(fi);
     erase(fi);
     while l > 0 do begin
       inc(i);
       s := dn + fun + '.#' + chr(i div 10+48) + chr(i mod 10 + 48);
       assign(fi, s);
{$I-}
       reset(fi, 1);
       while ioresult <> 0 do begin
         beep;
         writeln(inm, i, kes);
         getk;
         reset(fi, 1)
       end;
{$I+}
       m := filesize(fi);
       while m div bufsize > 0 do begin
         br(bufsize, 1);
         bw(bufsize);
         l := l - bufsize;
         m := m - bufsize
       end;
       br(m, 1);
       bw(m);
       l := l - m;
       close(fi);
       erase(fi)
     end;
     close(fo)
   end;

PROCEDURE init;
  begin
    writeln(am);
    writeln('Use it freely');
    if paramcount <> 3 then
      error(1);
    ddn := paramstr(3);
    if (ddn[2] <> ':') or (ddn[0] <> #2) then
      error(1);
    ddn[1] := upcase(ddn[1]);
    s := paramstr(2);
    s := fexpand(s);
    if length(s) < 5 then
      error(1);
    fun := s;
    dn := copy(s, 1, 2);
    fsplit(fun, s, fn, en);
    if en <> '' then
      delete(en, 1, 1);
    delete(fun, 1, 2);
    s := paramstr(1);
    wc := upcase(s[1]);
    getverify(verify);
    setverify(wc = 'V')
  end;

PROCEDURE main;
  label
    5, 6;
  begin
    case wc of
      'D', 'V':
      begin
        writeln(inm2, '0', kes);
        getk;
        assign(fi, dn+fun);
{$I-}
        reset(fi, 1);
        if ioresult <> 0 then
          error(2);
{$I+}
        l := filesize(fi);
        buf[1] := mem[dseg : ofs(l)];
        buf[2] := mem[dseg : ofs(l) + 1];
        buf[3] := mem[dseg : ofs(l) + 2];
        buf[4] := mem[dseg : ofs(l) + 3];
        while length(en) < 3 do
          en := en + ' ';
        buf[5] := ord(en[1]);
        buf[6] := ord(en[2]);
        buf[7] := ord(en[3]);
        m := discspace(ddn[1]);
        while m <= 0 do begin
          beep;
          writeln('This disk is full or bad. Insert another', kes);
          getk;
          m := discspace(ddn[1])
        end;
        m := m - 7;
        s := ddn + fn + '.#00';
      5:assign(fo, s);
{$I-}
        rewrite(fo, 1);
        if ioresult <> 0 then begin
          beep;
          writeln('This disk is bad. Insert another', kes);
          getk;
          goto 5
        end;
{$I+}
        if l <= m then
          m := l;
        l := l - m;
        while m div bufsize > 0 do begin
          br(bufsize, 8);
          bw(bufsize);
          m := m - bufsize;
          move(buf[bufsize + 1], buf[1], 7)
        end;
        br(m, 8);
        bw(m + 7);
        close(fo);
        if l > 0 then begin
          beep;
          writeln(inm2, '1', kes);
          getk
        end;
        i := 1;
        while l > 0 do begin
          m := discspace(ddn[1]);
          while m <= 0 do begin
            writeln('This disk is full or bad. Insert another', kes);
            getk;
            m := discspace(ddn[1])
          end;
          s := ddn + fn + '.' + '#' + chr(i div 10 + 48) + chr(i mod 10 + 48);
          inc(i);
        6:assign(fo, s);
{$I-}
          rewrite(fo, 1);
          if ioresult <> 0 then begin
            writeln('This disk is bad. Insert another', kes);
            getk;
            goto 6
          end;
{$I+}
          if l <= m then
            m := l;
          l := l - m;
          while m div bufsize > 0 do begin
            br(bufsize, 1);
            bw(bufsize);
            m := m - bufsize
          end;
          br(m, 1);
          bw(m);
          close(fo);
          if l > 0 then begin
            beep;
            writeln(inm2, i, kes);
            getk
          end
        end;
        close(fi);
        exit
      end;
      'C':
      begin
        j := pos('.', fun);
        if j > 0 then
          fun := copy(fun, 1, j - 1);
        repeat
          s := dn + fun + '.#00';
          assign(fi, s);
{$I-}
          reset(fi, 1);
          b2 := ioresult = 0;
{$I+}
          if not b2 then begin
            s := dn + fun + '.01$';
            assign(fi, s);
{$I-}
            reset(fi, 1);
            b1 := ioresult = 0;
{$I+}
          end;
          if not (b1 or b2) then begin
            writeln('Insert starting archival disk', kes);
            getk
          end
        until b1 or b2;
        if b1 then
          oldc
        else
          longc;
        exit
      end;
      'M':
      begin
        j := pos('.', fun);
        if j > 0 then
          fun := copy(fun, 1, j - 1);
        repeat
          s := dn + fun + '.#00';
          assign(fi, s);
{$I-}
          reset(fi, 1);
          if ioresult <> 0 then begin
            s := dn + fun + '.01$';
            assign(fi, s);
            reset(fi, 1);
            if ioresult = 0 then begin
              close(fi);
              error(3)
            end else begin
              writeln('Insert starting archival disk', kes);
              getk;
              continue
            end
          end;
{$I+}
          break
        until false;
        close(fi);
        longm;
        exit
      end else
        error(1)
    end
  end;

BEGIN
  init;
  main;
  error(0)
END.

